Attribute VB_Name = "ModDessinVue3D"
Option Explicit

Public Sub MainVisu3D()
   If IdWindowGlut = 0 Then
      ' Chargement de freeglut
      If LoadLibrary(App.Path & "\freeglut.dll") = 0 Then
          MsgBox "freeglut.dll introuvable"
          Exit Sub
      End If
      ' Initialisation de la machine d'tats de GLUT (OpenGL Utility Toolkit)
      glutInit 0&, ""
      glutInitDisplayMode GLUT_RGBA Or GLUT_DOUBLE Or GLUT_DEPTH 'voir http://www.linuxfocus.org/Francais/January1998/article16.html
      glutInitWindowSize 640, 480
      glutInitWindowPosition 0, 0
      ' Cration d'une fentre ; l'identifiant renvoy par Glut commence  1 (permet de savoir si une
      'fentre a t ouverte et de la fermer)
      IdWindowGlut = glutCreateWindow("Test OpenGL VB6")
      
      ' Dfinition de l'option de sortie de boucle
      glutSetOption GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_GLUTMAINLOOP_RETURNS
      'Lors de la fermeture de la fentre, on va passer par MyClose pour rinitialiser IdWindowGlut
      glutCloseFunc AddressOf MyClose
      ' Fonction d'affichage
      glutDisplayFunc AddressOf MyDisplay 'indique  GLUT o se trouvent les instructions qui tracent rellement dans la fentre
      ' Fonction d'attente ; REMARQUE importante : MyDisplay sera appele avant MyIdle
      glutIdleFunc AddressOf MyIdle  'indique  GLUT o allez quand il n'y a pas d'entre utilisateur -> on peut y mettre des modifs gres par le code, car on y passe  chaque tour de GlutMainLoop
      ' Fonctions de rappel clavier
      glutSpecialFunc AddressOf MySpecialKeyboard 'indique o se trouve les routines de gestion du clavier (touches spciales) ; glut transmet "key", "x", "y", voir le module
      ' Fonction de rappel molette de souris
      glutMouseWheelFunc AddressOf MyMouseWheel
      ' Fonction de rappel souris
      glutMouseFunc AddressOf MyMouseButton  'appui sur un bouton
      glutMotionFunc AddressOf MyMouseMoveWithButton  'dplacement avec un bouton appuy
      
      '****** initialisation de la scne ****
      ' Mode d'affichage = remplissage
      glPolygonMode GL_FRONT_AND_BACK, GL_FILL
      ' Tests de profondeur
      glEnable GL_DEPTH_TEST
      glDepthFunc GL_LEQUAL
      
      
      '****** Initialisation des variables de visualisation ****
      AnglePerspective = 55
      DistPlanProche = 0.1
      DistPlanEloigne = (EcartementZ + LongueurE + LongueurS + HauteurE + HauteurS) * 2  'pour tre sur que tout soit visible
      TranslateX = 0
      TranslateY = 0
      DistCamera = EcartementZ / 2 + LongueurE
      AngleX = 0
      AngleY = 0
      
      ' Lancement de la boucle infinie de GLUT
      glutMainLoop
   Else
      glutPostRedisplay
   End If
End Sub

'lors de la fermeture de la fentre, on rinitialise le numro identifiant la fentre
Public Sub MyClose()
   IdWindowGlut = 0
End Sub

'Fonction qui dfinit ce qu'il y a  faire quand pas d'entre utilisateur
Public Sub MyIdle()
   'on pourrait par exemple programmer un rafrachissement pour les objets en mouvement
End Sub

' Fonction d'affichage
Public Sub MyDisplay()
   Dim i As Long
   
   ' Passage en matrice de projection
   glMatrixMode GL_PROJECTION
   ' Initialisation de la matrice
   glLoadIdentity
   ' Dfinition de la perspective
   gluPerspective AnglePerspective, 1, DistPlanProche, DistPlanEloigne
   ' Passage en matrice de modlisation-visualisation
   glMatrixMode GL_MODELVIEW
   ' Initialisation de la matrice
   glLoadIdentity
   
   ' Position de la camra
   gluLookAt TranslateX, TranslateY, DistCamera, TranslateX, TranslateY, 0, 0, 1, 0
   
   ' Vide les buffers couleur et profondeur
   glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
   
   ' Sauvegarde la matrice
   glPushMatrix
      ' Rotation  partir de la souris
      glRotated AngleY, 1, 0, 0
      glRotated AngleX, 0, 1, 0
      
      'on va activer la transparence
      glEnable GL_BLEND
         glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
        ' l'enveloppe du prisme
         glBegin GL_TRIANGLE_STRIP  'triangles en bande
            'les points alternativement d'un ct et de l'autre
            For i = 1 To UBound(Points3D_E)
               glColor4d 1, 0, 0, 0.5
               glVertex3d Points3D_E(i).x, Points3D_E(i).y, Points3D_E(i).z
               glColor4d 0, 0, 1, 0.5
               glVertex3d Points3D_S(i).x, Points3D_S(i).y, Points3D_S(i).z
            Next i
         glEnd
         'Extrmits du prisme : test pour voir si les polygones concaves sont traits (S)
         'E
'         glBegin GL_POLYGON
'            For i = 1 To UBound(Points3D_E) - 1
'               glColor4d 1, 0, 0, 0.5
'               glVertex3d Points3D_E(i).x, Points3D_E(i).y, Points3D_E(i).z
'            Next i
'         glEnd
'         'S
'         glBegin GL_POLYGON
'            For i = 1 To UBound(Points3D_S) - 1
'               glColor4d 0, 0, 1, 0.5
'               glVertex3d Points3D_S(i).x, Points3D_S(i).y, Points3D_S(i).z
'            Next i
'         glEnd
         glBegin GL_LINE_STRIP  'lignes connectes pour faire apparatre l'arte
            For i = 1 To UBound(Points3D_E)
               glColor4d 1, 0, 0, 1
               glVertex3d Points3D_E(i).x, Points3D_E(i).y, Points3D_E(i).z
            Next i
            For i = 1 To UBound(Points3D_S)
               glColor4d 0, 0, 1, 1
               glVertex3d Points3D_S(i).x, Points3D_S(i).y, Points3D_S(i).z
            Next i
         glEnd
         ' le plateau en-dessous
         glBegin GL_QUADS  'quadrilatres d'extrmits
            For i = 1 To 4
               glColor4d 0, 1, 0, 0.3
               glVertex3d Points3D_PE(i).x, Points3D_PE(i).y, Points3D_PE(i).z
            Next i
            For i = 1 To 4
               glColor4d 0, 1, 0, 0.3
               glVertex3d Points3D_PS(i).x, Points3D_PS(i).y, Points3D_PS(i).z
            Next i
         glEnd
         glBegin GL_QUAD_STRIP  'enveloppe
            For i = 1 To 5
               glColor4d 0, 1, 0, 0.3
               glVertex3d Points3D_PE(i).x, Points3D_PE(i).y, Points3D_PE(i).z
               glVertex3d Points3D_PS(i).x, Points3D_PS(i).y, Points3D_PS(i).z
            Next i
         glEnd
      glDisable GL_BLEND ' Dsactive la transparence
   glPopMatrix ' Restaure la matrice

   ' Echange les buffers pour valider l'affichage : on travaille en double buffer pour viter le scintillement
   glutSwapBuffers

End Sub

'Fonction de gestion du clavier
Public Sub MySpecialKeyboard(ByVal key As Long, ByVal x As Long, ByVal y As Long) 'ATTENTION : on se sert de glutSpecialFunc
   Select Case key
   Case GLUT_KEY_UP
      DistCamera = DistCamera + EcartementZ / 5
   Case GLUT_KEY_DOWN
      DistCamera = DistCamera - EcartementZ / 5
   End Select
   glutPostRedisplay
End Sub

'gestion du zoom avec la molette de la souris
Public Sub MyMouseWheel(ByVal wheel As Long, ByVal direction As Long, ByVal x As Long, ByVal y As Long)
   Select Case direction
   Case 1
      DistCamera = DistCamera + EcartementZ / 5
   Case -1
      DistCamera = DistCamera - EcartementZ / 5
   End Select
   glutPostRedisplay
End Sub

'gestion des rotations  la souris
'*** dtermination de l'appui sur un bouton ***
Public Sub MyMouseButton(ByVal button As Long, ByVal state As Long, ByVal x As Long, ByVal y As Long)
   Select Case button
   Case GLUT_LEFT_BUTTON
      QuelBouttonSouris = 0
      If state = GLUT_DOWN Then
         BouttonPresse = True
         Xold = x
         Yold = y
      Else
         BouttonPresse = False
      End If
   Case GLUT_RIGHT_BUTTON
      QuelBouttonSouris = 2
      If state = GLUT_DOWN Then
         BouttonPresse = True
         Xold = x
         Yold = y
      Else
         BouttonPresse = False
      End If
   End Select
End Sub
'*** dplacement bouton appuy ***
Public Sub MyMouseMoveWithButton(ByVal x As Long, ByVal y As Long)
   If BouttonPresse = True Then
      Select Case QuelBouttonSouris
      Case 0  'bouton gauche
         AngleX = AngleX + (x - Xold) / 5
         AngleY = AngleY + (y - Yold) / 5
         'on rafraichit l'affichage
         glutPostRedisplay
         'on mmorise la position
         Xold = x
         Yold = y
      Case 2  'boutton droit
         TranslateX = TranslateX - (x - Xold) / (500 / LongueurE)
         TranslateY = TranslateY + (y - Yold) / (500 / LongueurS)
         'on rafraichit l'affichage
         glutPostRedisplay
         'on mmorise la position
         Xold = x
         Yold = y
      End Select
   End If
End Sub

