Attribute VB_Name = "ModOpenGLFontTools"
Option Explicit
'***************************************************************************************
'*                              Module openGL pour texte
'***************************************************************************************
' v0.1 - 04/11/2009
'***************************************************************************************
' http://arkham46.developpez.com
'***************************************************************************************
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" _
                                    (ByVal font_height As Long, ByVal font_width As Long, ByVal escapement As Long, _
                                     ByVal orientation As Long, ByVal weight As Long, ByVal italic As Long, _
                                     ByVal underscore As Long, ByVal strikeout As Long, ByVal character_set As Long, _
                                     ByVal output_precision As Long, ByVal clipping_precision As Long, ByVal quality As Long, _
                                     ByVal pitch_and_family As Long, ByVal face_name As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'---------------------------------------------------------------------------------------
' Cre les listes d'affichage pour la police pFontName de taille pSize
'---------------------------------------------------------------------------------------
Public Function CreateFontBitmap(pFontName As String, Optional pSize As Long = -20) As Long
Dim lFont As Long
Dim lOldFont As Long
Dim lbase As Long
Const ANSI_CHARSET = 0
Const SYMBOL_CHARSET = 2
Const OUT_TT_PRECIS = 4
Const CLIP_DEFAULT_PRECIS = 0
Const ANTIALIASED_QUALITY = 4
' Cration de listes pour les caractres allant de 32  255
lbase = glGenLists(255 - 32 + 1)
' Cration de la police de caractres
lFont = CreateFont(pSize, 0, 0, 0, 400, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY, 0, pFontName)
' Affecte la police de caractres au contexte d'affichage courant
lOldFont = SelectObject(wglGetCurrentDC, lFont)
' Gnre les listes d'affichages des caractres de  32  255
wglUseFontBitmaps wglGetCurrentDC, 32, 255 - 32 + 1, lbase
' Slectionne l'ancienne police et supprime la nouvelle qui tait temporaire
DeleteObject SelectObject(wglGetCurrentDC, lOldFont)
' Renvoie l'identifiant de la premire liste d'affichage
CreateFontBitmap = lbase
End Function

'---------------------------------------------------------------------------------------
' Affiche le texte pText  partir de la liste pListBase
'---------------------------------------------------------------------------------------
Public Sub DrawText(pText As String, pListBase As Long)
Dim lCpt As Long
Dim lbuffer() As Byte
' Cration d'un buffer contenant les codes ASCII des caractres  crire
ReDim lbuffer(1 To Len(pText))
For lCpt = 1 To Len(pText)
    lbuffer(lCpt) = Asc(Mid(pText, lCpt, 1))
Next
' Sauvegarde l'attribut GL_LIST_BIT qui sera modifi par glListBase
glPushAttrib GL_LIST_BIT
' Dfinit la liste de base (la premier caractre est de code ASCII 32)
glListBase pListBase - 32
' Appelle les listes pour afficher le texte
glCallLists Len(pText), GL_UNSIGNED_BYTE, lbuffer(1)
' Restaure l'attribut GL_LIST_BIT
glPopAttrib
End Sub

'---------------------------------------------------------------------------------------
' Cre les listes d'affichage 3D pour la police pFontName de taille pSize
'---------------------------------------------------------------------------------------
Public Function CreateFontOutline(pFontName As String, Optional pExtrusion As Single = 0) As Long
Dim lFont As Long
Dim lOldFont As Long
Dim lbase As Long
Dim lgf As GLYPHMETRICSFLOAT
Const ANSI_CHARSET = 0
Const SYMBOL_CHARSET = 2
Const OUT_TT_PRECIS = 4
Const CLIP_DEFAULT_PRECIS = 0
Const ANTIALIASED_QUALITY = 4
' Cration de listes pour les caractres allant de 32  255
lbase = glGenLists(255 - 32 + 1)
' Cration de la police de caractres
lFont = CreateFont(-20, 0, 0, 0, 400, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY, 0, pFontName)
' Affecte la police de caractres au contexte d'affichage courant
lOldFont = SelectObject(wglGetCurrentDC, lFont)
' Gnre les listes d'affichages des caractres de  32  255
wglUseFontOutlines wglGetCurrentDC, 32, 255 - 32 + 1, lbase, 0, pExtrusion, WGL_FONT_POLYGONS, ByVal 0&
' Slectionne l'ancienne police et supprime la nouvelle qui tait temporaire
DeleteObject SelectObject(wglGetCurrentDC, lOldFont)
' Renvoit l'identifiant de la premire liste d'affichage
CreateFontOutline = lbase
End Function




